Subject: Re: [PATCH net] net: txgbe: fix RTNL assertion warning when remove module

From: "Russell King (Oracle)" <[email-masked]>
Date: Wed, 1 Apr 2026 07:21:46 +0100

On Wed, Apr 01, 2026 at 10:16:34AM +0800, Jiawen Wu wrote:
> On Tue, Mar 31, 2026 9:08 PM, Russell King (Oracle) wrote:
> > On Tue, Mar 31, 2026 at 03:11:07PM +0800, Jiawen Wu wrote:
> > > For the copper NIC with external PHY, the driver called
> > > phylink_connect_phy() during probe and phylink_disconnect_phy() during
> > > remove. It caused an RTNL assertion warning in phylink_disconnect_phy()
> > > upon module remove.
> > >
> > > To fix this, move the phylink connect/disconnect PHY to ndo_open/close.
> > 
> > Wouldn't it be simpler to just wrap the phylink_disconnect_phy() in the
> > remove function with rtnl_lock()..rtnl_unlock() ?
> 
> This is also a solution. But I think it would be nice to unify with other drivers
> that call the functions in ndo_open/close.

Both approaches are equally valid. Some network drivers attach the PHY
at probe time (and thus can return -EPROBE_DEFER if the PHY is specified
but not present). Others attach in .ndo_open which can only fail in this
circumstance with no retry without userspace manually implementing that.

There are other advantages and disadvantages to each approach.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!